unit nwiproc;

interface

uses objects,
     nwitype;

function GetRights(x:word):string;
function Name2ID(name:string;typ:word):longint;

procedure GetUserTrustees(vol:byte;objid:longint;var coll:TNWColl);
procedure GetUser(var coll:TNWColl);
procedure GetObjNames(object_name:string;Group:boolean;var coll:TNWColl);
procedure GetVolumes(var coll:TNWColl);
function GetRealName(user:string):string;
function LeftStr(s :string; l :byte) :string;
function RightStr(s :string; l :byte) :string;
function GetManaged(user:string):string;
procedure GetNodeRes(user:string; var coll :TNWColl);
procedure getVolumeRestrictions(user :longint; var vol, VolRest :tnwcoll);
procedure GetProp(user:string; propType :string;var coll:TNWColl);
procedure GetAccount(user:string);
procedure GetLoginScript(userid:longint);
procedure GetHelp;
function GetMyName:string;

procedure GetRelationObjects(user:string;typ:word;id:string;var coll:TNWColl);

implementation

uses nwfile,nwbindry,nwmisc,nwconn;

function GetRights(x:word):string;
var s:string;
begin
  s:='[SRWCEMFA]';
  if (x and TA_Supervisor)=0 then s[2]:=' ';
  if (x and TA_READ)=0 then s[3]:=' ';
  if (x and TA_WRITE)=0 then s[4]:=' ';
  if (x and TA_CREATE)=0 then s[5]:=' ';
  if (x and TA_DELETE)=0 then s[6]:=' ';
  if (x and TA_MODIFY)=0 then s[7]:=' ';
  if (x and TA_SEARCH)=0 then s[8]:=' ';
  if (x and TA_ACCESS)=0 then s[9]:=' ';
  Getrights:=s;
end;

function Name2ID(name:string;typ:word):longint;
var id:longint;
begin
  if GetBinderyObjectID(name,typ,id)
    then Name2ID:=id
    else Name2ID:=0;
end;

procedure GetUserTrustees(vol:byte;objid:longint;var coll:TNWColl);
var
    TruSeq:word;
    AccessMask:word;
    Path:String;
begin
  truseq:=0;
  while ScanBinderyObjectTrusteePaths(objID,vol,TruSeq,AccessMask,Path) do
    coll.insert(newstr(getrights(AccessMask)+' '+path));
end;


procedure GetUser(var coll:TNWColl);
var
    lastseen,objId:LongInt;
    object_name,objName:String;
    objHasProp:Boolean;
    objType:Word;
    objFlag,objSecurity:Byte;
    u:PNWUser;

    accLevel:Byte;
begin
  coll.freeall;

  GetBinderyAccessLevel(accLevel,objId);
  IF accLevel=(BS_SUPER_READ or BS_SUPER_WRITE)
   then object_name := '*'  { wildcard }
   else
     begin
       GetBinderyObjectName(objID,objName,objType);
       object_name := objName;
     end;

  lastseen := -1;      { first entry }

  while ScanBinderyObject(object_name,OT_USER,
                          lastseen,
                          objName,objType,objID,
                          objFlag,objSecurity,objHasProp) do
    begin
      u:=new(PNWUser,init);
      u^.Name:=objName;
      u^.id:=ObjID;
      coll.insert(u);
    end;
end;

procedure GetObjNames(object_name:string;Group:boolean;var coll:TNWColl);
var
    lastseen,objId:LongInt;
    objName:String;
    objHasProp:Boolean;
    o_typ,objType:Word;
    objFlag,objSecurity:Byte;
begin
  coll.freeall;

 { GetBinderyAccessLevel(accLevel,objId);
  IF accLevel=(BS_SUPER_READ or BS_SUPER_WRITE)
   then object_name := '*'
   else
     begin
       GetBinderyObjectName(objID,objName,objType);
       object_name := objName;
     end;
  }
  lastseen := -1;      { first entry }
  if Group then o_typ := OT_USER_GROUP
           else o_typ := OT_USER;

  while ScanBinderyObject(object_name,o_typ,
                          lastseen,
                          objName,objType,objID,
                          objFlag,objSecurity,objHasProp) do
    coll.insert(newStr(objName));
end;

procedure GetVolumes(var coll:TNWColl);
var i:byte;
    name:string;
begin
  coll.freeall;
  for i:=0 to 31 do
    if GetVolumeName(i,name) then
      coll.insert(newstr(name));
end;


function GetRealName(user:string):string;
var rn:string;
begin
  GetRealUserName(user,rn);
  GetRealName:=rn;
end;

function LeftStr(s :string; l :byte) :string;
var hs :string;
    i  :byte;
begin
  hs:=copy(s,1,l);
  for i:=length(hs) to l-1 do hs:=hs+' ';
  LeftStr:=hs
end;

function RightStr(s :string; l :byte) :string;
var hs :string;
    i  :byte;
begin
  hs:=copy(s,1,l);
  for i:=length(hs) to l-1 do hs:=' '+hs;
  RightStr:=hs
end;

function GetManaged(user:string):string;
var seqnr:longint;
    objtyp,
    objnr:word;
    objname:string;
    info:TobjIdArray;
    s:string;
    i:byte;
begin
  s:='<none>';
  seqnr:=-1;
  if GetRelationOfBinderyObject(user,OT_USER,'OBJ_SUPERVISORS',
                                   seqnr,objnr,info) then
    if objnr>0 then
      begin
        s:='';
        for i:=1 to objnr do
          begin
            GetBinderyObjectName(info[i],objname,objtyp);
            s:=s+objName;
            if i<objnr then s:=s+', ';
          end;
      end;
  GetManaged:=s;
end;

procedure GetRelationObjects(user:string;typ:word;id:string;var coll:TNWColl);
var seqnr:longint;
    objtyp,
    objnr:word;
    objname:string;
    info:TobjIdArray;
    i:byte;
begin
  coll.freeAll;
  seqnr:=-1;
  if GetRelationOfBinderyObject(user,typ,id,seqnr,objnr,info) then
    if objnr>0 then
      begin
        for i:=1 to objnr do
          begin
            GetBinderyObjectName(info[i],objname,objtyp);
            coll.insert(newstr(objname));
          end;
      end;
end;

procedure GetNodeRes(user:string; var coll :TNWColl);
var seqnr:longint;
    objtyp,
    objnr:word;
    objname:string;
    info:TobjIdArray;
    s, hs:string;
    i:byte;
    propName      :String;

    propValue   : Tproperty;
    moreSegments: Boolean;
    propFlags: byte;
begin
  s:='<none>';
  seqnr:=1;
  s:='';
  while readpropertyvalue(user,OT_USER,'NODE_CONTROL',seqnr,
                         propValue,moreSegments,propFlags) do
    begin
      i:=1;
      repeat
        hs:=hexdumpstr(propValue[i],8);
        if hs<>'00000000' then begin
          s:=hs+':';
          hs:=hexdumpstr(propValue[i+4],12);
          if hs='FFFFFFFFFFFF' then s:=s+'<all Nodes> '
                               else s:=s+hs;
          coll.insert(newstr(s))
        end;
        i:=i+10;
      until i>=128-10;
      inc(seqnr);
    end;
end;

function getblocksize(j :byte) :word;
var t:byte;
    VolUsage :tvolusage;
begin
  if GetVolumeUsage(j, VolUsage) then begin
    t:=VolUsage.SectorsperBlock div 2
  end else
    t:=0;
  getblocksize:=t
end;

procedure getVolumeRestrictions(user :longint; var vol, VolRest :tnwcoll);
var j :byte;
    MaxAllowedBlocks,BlocksInUse:LongInt;
    s,hs :string;
    isremvbl :boolean;
    bs :word;
begin
   for j:=0 to Vol.count-1 do begin
     s:=LeftStr(pstring(vol.at(j))^+': ',10);
     if isvolumeremovable(j,isremvbl) then
       if isremvbl then begin
         s:=s+'<removable>';
         VolRest.insert(newstr(s))
       end else
         bs:=getblocksize(j);
         if GetObjectVolRestriction(j, user, MaxAllowedBlocks,BlocksInUse) then begin
           str(blocksinuse*bs,hs);
           s:=s+rightstr(hs,9)+' kB in use, ';
           if maxallowedblocks=$40000000 then
             s:=s+'<no Restriction>'
           else begin
             str(maxallowedblocks*4,hs);
             s:=s+rightstr(hs,9)+' kB max. allowed'
           end;
           VolRest.insert(newstr(s))
         end
   end
end;


procedure GetProp(user:string; propType :string;var coll:TNWColl);
Type string30=string[30];
     PobjRec =^objRec;
     objRec  =Record
              objId:LongInt;
              name:string30;
              next:PobjRec;
              end;

Var PstartObj:Pobjrec;

  procedure ShowSet(pset:Tproperty);
  Var i    :Byte;
      objId:LongInt;
      objname:string;
      objtype:word;
  begin
  { A segment of a set-property consists of a list of object IDs,
    each ID 4 bytes long, stored hi-lo.
    The end of the list (within THIS segment) is marked by an ID of 00000000. }
    i:=1;
    Repeat
     objId:=MakeLong((pset[i] *256 +pset[i+1]), ( pset[i+2] *256 + pset[i+3] ) );
     if objId<>0 then
       begin
         GetBinderyObjectName(objID,objname,objtype);
         coll.insert(newstr(objname));
       end;
     inc(i,4);
    Until (i>128) or (objId=0);
  end;

var seqnr:longint;
    objtyp,
    objnr:word;
    objname:string;
    info:TobjIdArray;
    hs:string;
    i:byte;
    propName      :String;

    propValue   : Tproperty;
    moreSegments: Boolean;
    propFlags: byte;
begin
  coll.freeall;
  seqnr:=1;
  repeat
    if readpropertyvalue(user,OT_USER,PropType,seqnr,
                         propValue,moreSegments,propFlags)
      then ShowSet(propvalue);
    inc(seqnr);
  until not moreSegments;
end;

function GetNovTime(nt:TNovTime;time:boolean):string;
var s:string;
begin
  if nt.year <> 0 then
    begin
      NovTime2String(nt,s);
      delete(s,1,5);
      if not time then delete(s,12,9);
      GetNovTime:=s;
    end else GetNovTime:='<never>';
end;

procedure GetAccount(user:string);
var lc: TloginControl;
    NullAddress:TInterNetworkAddress;
begin
  fillchar(NullAddress,sizeof(NullAddress),0);
  getobjectlogincontrol(user,OT_USER,lc);
  with lc do
    begin
      if AccountDisabled then writeln('   Account Disabled.');
      if AccountExpirationDate.year>0 then
        writeln('   Account Expires on: ',GetNovTime(AccountExpirationDate,false));
      if minimumpasswordlength >0 then
        writeln('   minimum password length: ',minimumpasswordlength);
      case PasswordControlFlag of
        $01: writeln('   User is NOT allowed to change PW.');
        $02: writeln('   User is allowed to change PW, but the new password must be unique.');
        $03: writeln('   User is NOT allowed to change PW, and a new password, to be changed '+
                     'by the supervisor, must be unique.');
      end;
      if PasswordExpirationDate.year>0 then
        writeln('   Password Expiration Date: ',GetNovTime(PasswordExpirationDate,false));
      writeln('   last login: ',GetNovTime(LastLoginTime,true));

      if GraceLoginsRemaining<> $FF then
        writeln('   Grace Logins Remaining: ',GraceLoginsRemaining);
      if MaxGraceLoginsAllowed <> $FF then
        writeln('   Max Grace Logins Allowed: ',MaxGraceLoginsAllowed);
      case BadLoginCount of
         $FF: if AccountResetTime.year>0 then
                writeln('   Account Disable until: ',GetNovTime(AccountResetTime,true));
         0:;
         else writeln('   Bad Login Count: ',BadLoginCount);
      end;
      if not isEqualNetworkaddress(LastIntruderAddress,NullAddress) then
        writeln('   Last Intruder Address: ',
                hexdumpstr(LastIntruderAddress.net,8),':',
                hexdumpstr(LastIntruderAddress.node,12));
      if MaxConcurrentConnections >0 then
        writeln('   Max Concurrent Connections: ',MaxConcurrentConnections);
    end;
end;


procedure GetLoginScript(userid:longint);
var path,line:string;
    t:text;
    c:word;
begin
  path:=hexstr(userid,8);
  while path[length(path)]='0' do dec(path[0]);
  while path[1]='0' do delete(path,1,1);
  path:='SYS:MAIL\'+path+'\LOGIN';
  assign(t,path);
  {$I-} reset(t); {$I+}
  if ioresult <>0 then writeln('<not found>')
    else begin
      c:=0;
      while not eof(t) do begin
        readln(t,line);
        writeln('   ',c,': ',line);
        inc(c);
      end;
      if c=0 then writeln('<empty>');
      close(t);
    end;
end;

procedure GetHelp;
begin
  writeln('   Netware Info, O.Schmidt, H.Hansen, 6.2.96'^j);
  writeln('Options:');
  writeln('   A: Show Account Information');
  writeln('   G: Show Groups belonged to');
  writeln('   R: Show Station Restrictions');
  writeln('   M: Show Managed Users/Groups');
  writeln('   N: Show Manages');
  writeln('   S: Show Security Equivalences');
  writeln('   V: Show Volume Restrictions');
  writeln('   T: Show Trustee assignments'^j);
  writeln('   P: Print pagebreak');
  writeln('   C: Show User while piping (nwinfo 0 > xy.inf)'^j);
  writeln('   0: Show ALL infos'^j);
  halt;
end;

function GetMyName:string;
var
    objId:LongInt;
    objName:String;
    objType:Word;
    accLevel:Byte;
begin
  GetBinderyAccessLevel(accLevel,objId);
  GetBinderyObjectName(objID,objName,objType);
  GetMyName:=objName;
end;

end.